Changes in version 0.8-17 (22-03-2024)
======================================

- Log4J 2 support

Changes in version 0.8-16 (29-11-2023)
======================================

- Corrected some confidence interval calculations. Thanks to Liane Kluge for spotting!
- Dropped Java 5 and 6 compatibility
- No online version check anymore - gMCP is pretty stable now
- Removed Deducer from suggest list
- Corrected links (https and doi were appropriate)
- Using inherit function instead of class comparisons
- Updated homepage from r-forge to gitlab
- Using bibentry instead of citEntry for citation
- Removed old-style PersonList syntax from CITATION file

 57 files changed, 423 insertions(+), 371 deletions(-)

Changes in version 0.8-15 (01-03-2020)
======================================

- Updated gMCP-package.Rd

Changes in version 0.8-14 (09-07-2018)
======================================

- Updated gMCP-package.Rd

Changes in version 0.8-13 (11-12-2017)
======================================

- Updated documentation.

- Dontrun Java example for standard tests.


Changes in version 0.8-12 (04-12-2017)
======================================

- Fixed warnings in .onLoad.

- Added options to graph2latex. Especially fill colors can be set globally 
  now by for example options(gMCP.fill.retain = "green!10").

- Changed the RUnit log directory from the package directory to 
  the working directory. (And no log is written during installation.)


Changes in version 0.8-11 (13-11-2017)
======================================

- Fixed warnings in .onLoad.

- Native routine registration.

- Java 9 compatibility.


Changes in version 0.8-10 (31-08-2015)
======================================

- Power calculations in the GUI are displayed in a JTable with easy
  copy to clipboard and into Excel support and can also be sorted.

- Work on upscale parameter. Adjusted p-values from parametric tests are 
  now consistent to the results from generateTest().
  You can pass 'upscale="o3"' in 'generatePvals' to use the old method.

- Default for parameter keepWeights in rejectNode and gMCP is now FALSE,
  which has no impact on test results (it's just a matter of taste how
  to display these graphs with rejected nodes), but reduces confusion with 
  parameter upscale.

- Graph for Bonferroni-Holm procedure gains argument weights for the
  weighted Bonferroni-Holm procedure.

- New function sampSize for sample size calculations (work in progress)

- Graphical user interface for sample size calculations (work in progress)

53 files changed, 780 insertions(+), 4699 deletions(-)


Changes in version 0.8-9 (10-08-2015)
=====================================

- New function gMCP.extended, which mostly does the same as the old
  gMCP function, but separates more clearly between weighting scheme
  and the subsequent closed testing procedure (with possible shortcuts).
  See ?gMCP.extended for the documentation of this new function.
  
- gMCP.extended can take any weighted test function as argument.
  The trimmed one-sided Simes test for two hypotheses and the weighted 
  Simes test for specified subsets (and Bonferroni otherwise) are two 
  new weighted test functions provided by this package.
  See ?bonferroni.trimmed.simes.test and ?simes.on.subsets.test for details.

- When a graph is saved, the user now can decide whether p-values and
  chosen test (including possible correlation matrix) should also be
  saved as attributes attached to the graph. If such a graph is loaded
  the user can choose whether he wants to restore p-values and/or test
  information.

- Saving a graph as PNG image file opens a dialog with the following
  options and a live preview: Color, transparent background, drawing
  of hypotheses names and weights, drawing of edge weights and node
  radius.

- Node size can be changed (e.g. for longer hypotheses names).

- Fixed some help documents not showing up as expected.

- Added new help buttons in the GUI which directly open the relevant
  sections of the user manual.

- Better layout for result window when large graphs or Simes test 
  is used.
  
- Function calcPower now also takes graphMCP objects.

- Improved Edges

- Fixed call of corMatWizard if only a matrix is given without names
  and dimensions.

- Fixed confusing (but mostly not relevant) mix-up between NA and NaN
  during R/Java conversions.

- Better handling of invalid LaTeX terms.

- graph2latex gains argument 'fig.caption.short' for an optional short
  version of fig.caption for the list of figures.

- Fixed logging errors/warnings when two different users used the gMCP
  GUI on the same system.
  
- Improved dialog in case of errors.

- Warning if R was compiled without shared library support and the 
  graphical user interface will not be available due to missing JRI.
  
- Lots of small interface improvements and documentation additions.

- Extended RUnit tests 

 144 files changed, 10027 insertions(+), 1106 deletions(-)


Changes in version 0.8-8 (03-10-2014)
=====================================

- API FUNCTION PARAMETER CHANGE: The argument 'exhaust' in the functions
  'generateBounds', 'generatePvals' and 'generateTest' was renamed to
  'upscale' to reduce misinterpretation.

- Since CRAN currently will build binaries only for 3.0 and 3.1, we
  drop support for R < 3.0.0 in the official releases to make our
  lives easier. Nevertheless there is a branch pre-R3 on github for
  those interested (or simply contact us if you are using an older
  version of R).

- Up to now the parameter 'test' of function gMCP could be one of the
  following: "Bonferroni", "Simes", "Bretz2011" or "simple-parametric".

  We now introduced a new parameter 'upscale' (default FALSE) and
  restricted 'test' to: "Bonferroni", "Simes" and "parametric", where
  the old "Bretz2011" corresponds to 'test="parametric", upscale=TRUE'
  and the old "simple-parametric" to 'test="parametric", upscale=FALSE'.  

  For compatibility the old function calls actually still work, but
  are discouraged.

- The parameters 'cr' and 'sigma' in function 'calcPower' were renamed
  into 'corr.test' and 'corr.sim' respectively to further clarify that
  both are correlation matrices, the first used for the test (this
  matrix may contain NAs if the full correlation is not known for the
  test) and the second one for the simulation (which can not contain
  NAs and may also differ from the first one if power under
  misspecification is investigated).  For compatibility the old
  function calls actually still work, but are discouraged.

- Fixed: The (experimental) power calculations were off for graphs
  where not all subgraphs created by rejections have the full alpha
  level.
  Thanks to Yevgen Tymofyeyev for spotting this!

- The function graph2latex got a new parameter 'showAlpha'. Now per
  default the graph weights are shown and not the local alpha levels
  in the nodes. The old output can be reproduced by setting
  'showAlpha' to TRUE.

- Fixed: Graph image exports were not possible due to some recently
  introduced bug.

- Fixed: Some matrices were completely grayed out although only the diagonal 
  was not editable.

- Random seed is shown for results from methods which use random
  numbers and can be set via options.

- Support for entangled graphs is no longer highly experimental, 
  but enabled as default.

- Support for parametric tests for entangled graphs, i.e. 'generatePvals'
  and 'generateWeights' accept entangled graphs now.

- For entangled graphs there is now more than one tab showing the graph:
  The first tab still shows the combined graphs and then a separate tab
  for each graph follows.

- Settings for power calculations are saved temporarily or between sessions.
  
- The (disabled) menu entry for PDF reports was replaced by functionality
  for Office Open XML (MS Word docx) support. Package xlsxjars is therefore
  now a dependency (IMPORTS), since it already provides the necessary
  Apache POI jar files.

- Settings in the dialogs for power analysis and sample size calculations
  are remembered and can be saved and loaded as XML files.

- Improved Graph Analysis checks whether weights sum up to 1 for all subgraphs.

- In case of unexpected errors on Java's Event-Dispatch-Thread no error dialog
  was shown if Java >=7 was used. This is now fixed. Also error handling
  is now more robust.

- Edges are highlighted if transition matrix cells are edited.

- New example graph from Wang, B. and Ting, N. (2014): "An Application
  of Graphical Approach to Construct Multiple Testing Procedures in a
  Hypothetical Phase III Design."  Frontiers in public health, 1 (75).

- Fixed: In some cases the description of the graph objects was not loaded.

- Fixed: A backslash '\' in the graph description could crash the GUI
  including R.

- Better handling of unintentionally entered NaN or infinity values.

 191 files changed, 8047 insertions(+), 3575 deletions(-) [git diff --stat v0.8-7..master]

Changes in version 0.8-7 (26-08-2014)
=====================================

- Compatible to CommonJavaJars 1.0-5.

- Fixed CRAN warnings.

- Moved Java source to /java as requested by CRAN.

- Dropped Deducer integration for now.

 41 files changed, 2089 insertions(+), 278 deletions(-)


Changes in version 0.8-6 (17-02-2014)
=====================================

- Improved memory settings. Especially in R 2.15.1 and 2.15.2 on 32-bit systems 
  errors like the following could occur when the GUI was used:
  java.lang.OutOfMemoryError: unable to create new native thread

- Fixed: When the value of the alpha field was not a valid number in the GUI,
  an infite loop of warning dialogs popped up.
  
- Fixed: Loading old graph objects from version 0.6.x, i.e. from before August 2011,
  without package 'graph' asks to install this package. If this is refused or
  the installation failed, bad things happened like a complete crash of the current
  R session.

- Function 'graph2latex' gains an argument 'scaleText'. If TRUE (default)
  a scalebox is used in LaTeX instead of the optional parameter 'scale'
  from the tikzpicture environment.

- Improved documentation. Some Rd files are built by a patched version of
  roxygen2 that escapes "\" in arguments and understands "returnItem": 
  install_github("roxygen2", username="kornl")
  (This version includes especially Yihui's pull request: 
   https://github.com/klutometis/roxygen/pull/112 
   and A. Alfons's pull request:
   https://github.com/klutometis/roxygen/pull/30 )

- Using RCallServicesREngineWrapper to eval each expression in the environment 
  gMCP:::gMCPenv instead of the global environment.

- Some errors were catched in Java or R, but still showed up in the console.
  We now use 'try(..., silent=TRUE)' in these cases.

- Adjacency Matrix is renamed to Transition Matrix (since some people 
  use the word Adjacency Matrix for the binary matrix).

- We always use correlation matrices instead of covariance matrices in the GUI.

 139 files changed, 5526 insertions(+), 3428 deletions(-)


Changes in version 0.8-5 (18-07-2013)
=====================================

- Removed dangerous parameter seed from function rqmvnorm and calcPower.

- POSIX conforming Makefile fixes problems under Solaris.

- Fix for problems with knitr 1.3.

- Fixed: The rarly used offset parameter did not work well with the new edges 
   consisting of arcs in TikZ.

 24 files changed, 88 insertions(+), 248 deletions(-)


Changes in version 0.8-4 (15-07-2013)
=====================================

- R's base function chol for the Choleski Decomposition now defaults to LAPACK 
  in R 3.0 resulting in meaningless results for not non-negative definite 
  matrices (without any numerical tolerance! And in R devel it is by now defunct: 
  ‘chol(pivot = TRUE, LINPACK = TRUE)’ is defunct.). 
  Therefore power calculations for only semi-positive definite correlation 
  matrices could have been off under R 3.0 in previous versions.
  We switched to the singular value decomposition.

- Fixed: List of user defined power functions doesn't need to have names.

- Further work on the experimental entangled graphs feature.

- Since the vignettes were moved from gMCP/inst/doc to gMCP/vignettes
  most likely they will only be build with R >= 2.14.0.

- Moved MASS, PolynomF, multcomp, lattice, mvtnorm, Matrix, CommonJavaJars and 
  methods from DEPENDS to IMPORTS. Therefore loading gMCP will no longer add 
  these packages to the search path and if for example you want to use 
  contrMat from package multcomp you have to load/attach the package yourself.

 37 files changed, 437 insertions(+), 136 deletions(-)


Changes in version 0.8-3 (14-06-2013)
=====================================

- If a correlation matrix is selected in the main window, the same 
  correlation matrix is loaded per default in the power analysis dialog.

- To comply with CRAN policies the function graphGUI has now an argument
  envir to specify in which environment the object graph is located and/or 
  it should be saved (default is the global environment).

 41 files changed, 422 insertions(+), 140 deletions(-)


Changes in version 0.8-2 (14-06-2013)
=====================================

- The output of graph2latex has greatly improved and you nearly get 
  in TikZ what you can see in the Java GUI. 

- Fixed a bug existing in gMCP 0.7-11 to 0.8-1 which caused calculations with
  multiple power settings in the GUI to stop with an error.
  
- The official source repository switched from subversion/r-forge to git/github:
  https://github.com/kornl/gMCP
  (R package devtools from Hadley Wickham et al. can be used to install
  development versions.)
  Instead of subversion revision numbers you will find annotated tags specifying 
  the versions in the git repository.
  
 (This version was not accepted on CRAN. See news for version 0.8-3.)


Changes in version 0.8-1 (06-04-2013, Rev. 1567)
================================================

- An rJava update to 0.9-4 removed necessary files for gMCP 0.8-0.
  This is now fixed and CommonJavaJars (>= 1.0.3) are required.

- Since package highlight is now orphaned we instead use knitr.

- Fix for loading the namespace when just the base namespace is loaded.

 28 files changed, 177 insertions(+), 197 deletions(-)
 

Changes in version 0.8-0 (14-10-2012, Rev. 1536)
================================================

- Fixed: If edges or nodes were changed with a double click,
  after that an error dialog was shown although nothing was wrong. 

- Fixed: You could not change the type of parametric test in the options.

- You can select more than one node or edge and move them around.

- New class for entangled graphs (graphs with memory, i.e. linear convex 
  combinations of graphs with the same nodes).

- Better error messages when input doesn't meet demands.

- Improved: Power simulations for singular correlation matrices.

- Entangled graphs (graphs with memory, i.e. linear convex combinations of graphs 
  with the same nodes) as experimental feature (has to be activated in the options).

- Two entangled example graphs (Entangled1Maurer2012, Entangled2Maurer2012)
  from Maurer et al.

- New example graph from Ferber et al. 2011.

- Tooltips in options dialog.

- Improved power dialog.

 86 files changed, 3005 insertions(+), 1600 deletions(-)


Changes in version 0.7-12 (02-08-2012, Rev. 1420)
================================================

- Fixed: Sequentially rejective test procedures could not be reproduced 
  step-by-step in the GUI - although the shown result was correct.

- gMCP 0.7-11 relied on function regmatches that was introduced in R 2.14. 
  Therefore the GUI did not work for R 2.13 and previous versions.
  This is fixed now and gMCP is again compatible with older R versions
  including R 2.8.0.
  
- Removed error messages (that could be safely ignored) in the R console 
  when graphs with variables were shown in the GUI.

 24 files changed, 439 insertions(+), 60 deletions(-)

 
Changes in version 0.7-11 (21-07-2012, Rev. 1404)
================================================

- GUI shows R code to reproduce results in R.

- The graph area has now a pop-up menu on right click.

- Fixed a bug introduced in the last versions:
  In the GUI the alpha-Field was always set back to 0.05 regardless 
  of what the user entered.

- For some graphs the Simes-procedure produced errors when
  pvalues were exactly 0 (while not relevant for practical use
  this was frustrating when experimenting with graphs).

- Stated at more places what parametric tests do and 
  which prerequisites must be met.
  Also there is no default anymore for parametric tests.
  The user has to decide between "simple-parametric" and "Bretz2011".

- Function replaceVariables can handle greek and latin alphabet
  and gained argument "ask" for interactive sessions.

- Round output of power simulations to level of precision.

- When graphs are saved from the GUI the slot graph@m is now
  always numeric when no variables are involved.  

- Method calcPower does not always set the seed as default.

- Power simulations for different variable values. 

- The GUI is updated immediately after renaming of nodes.

- The Reset Button resets to the graph with variables.  

- A backslash is allowed in node names (e.g. \alpha) in the GUI.

- corMatWizard is a new function that opens a Java dialog for
  correlation matrix creation.
  
- Fixed a rather unimportant bug that unintended entering of 
  Infinity (e.g. "2/0") causes a loop of error messages.

- Extended unit tests. See method unitTestsGMCP.
  Option extended=TRUE will run small power simulations.
  Option java=TRUE will run JUnit tests for GUI testing.
  Option interactive=TRUE will run interactive tests.
  
- Added a few message dialogs with additional information.
  All of these can be disabled by a CheckBox:
  "Don't show me this info again."

- Epsilon edges can be (optionally) shown as dashed lines.

- New example graph from Ferber et al. 2011.

- Fixed an error that occured if a graph was exported as PNG file
  and was really close to the border of the visible area. 

- During testing menu entries for loading graphs were not
  disabled, but did not work in this case. Now they always work.
 
 97 files changed, 1841 insertions(+), 767 deletions(-)
 

Changes in version 0.7-10 (15-06-2012, Rev. 1291)
================================================

- New self test function doUnitTestsForGMCP to check whether
  the R unit test suite for gMCP can complete without errors.

- To reduce problems for older systems our C code does not contain 
  any C99 features any more. (For R > 2.12 an ISO C99 C compiler is 
  required. For older systems this was not the case.)
  
- Added option "exhaustAlpha" directly to the gMCP function to allow 
  non-alpha-exhaustive parametric tests. Also a note is given
  if exhaustAlpha=TRUE would change the result.  
  
 18 files changed, 137 insertions(+), 47 deletions(-)


Changes in version 0.7-9 (07-05-2012, Rev. 1277)
================================================

- calcPower gained a parameter "cr" for specifying
  a correlation for parametric power simulations. 

- Added option to allow non-alpha-exhaustive parametric tests.

- Improved dialog in GUI for power simulations, 
  including multiple settings for power analysis.

- Improved font size adjustment for edge labels.

- Show syntax error instead of infinite loop if an unparseable edge weight is entered. 

 33 files changed, 720 insertions(+), 190 deletions(-)
 

Changes in version 0.7-8 (06-03-2012, Rev. 1252)
================================================

- Edges can be created by drag'n'drop. 
  (Drag from the first node and drop on the second node.)
  
- Button to add edges stays pressed down until it is pressed again (or edges are added).
  This allows faster creation of graphs with many nodes.

- Fixed (unproblematic but annoying) NullPointerException with drag'n'drop
  introduced in 0.7-7.

- Fixed an error window popping up (but nothing was wrong at all) in the
  rare case that while dragging an edge it was double clicked and deleted.
  
- If edge weights are NULL, the weightStr is set to "NULL" instead of 
  throwing a RuntimeException.
  
- Fixed: Check for negative eigen values always resulted in the message
  that the matrix can not be processed due to NA values.

 14 files changed, 136 insertions(+), 45 deletions(-)
 

Changes in version 0.7-7 (17-02-2012, Rev. 1236)
================================================

- Fixed severe (but at least obvious) regression in 0.7-6: All p-values beyond the
  first one were always immediately set to 0.

- Simes test calculates also pvalues. An extra option adjPValues=TRUE is added to
  the gMCP function. Setting this to FALSE will sometimes increase the speed 
  (and memory consumption) of the Simes test significantly.

- New wizard for the creation of correlation matrices.
  
- Reordering of hypotheses is possible (important for e.g. correlation matrices).
  Java 5 users: Rearranging nodes with drag'n'drop does not yet work for you. 

- If the entered matrix is not positive semidefinite, 
  i.e. negative eigen values exist, a warning is given.

- New S4 method getMatrix for getting the adjacency matrix from a graphMCP object.

- Fixed regression in 0.7-6: CI and p-value buttons for parametric tests
  were sometimes enabled and sometimes disabled.

 28 files changed, 467 insertions(+), 223 deletions(-)


Changes in version 0.7-6 (13-02-2012, Rev. 1208)
================================================

- JTable behaves slightly different now:
  Whenever a cell gets the focus the CellEditor is opened.
  Also already existing text is selected to make overwriting easier.
  You can change this behavior in the options.

- Fixed: With Java 5 it was sometimes hard to edit the cells of JTables.  

- Fixed: NullpointerException when loading R objects.

- Fixed (regression): greek characters were shown in the 
  adjacency matix with leading backslash
  
- Fixed: In rare cases (i.e. only information about correlation was changed)
  old results were displayed if reset was not used.

- rqmvnorm does not set a seed by default.
 
- If a graph is saved the p-values are automatically attached to the 
  graphMCP objects as an attribute "pvalues".

- New option: Should the exported image of a graph have 
  an white or transparent background.

 63 files changed, 591 insertions(+), 277 deletions(-)


Changes in version 0.7-5 (29-01-2012, Rev. 1147)
================================================

- Better draw routine: Edges start and end now precisely at the borders of the nodes. 

- For the resulting graph a new option keepWeight
  is introduced in the functions gMCP and rejectNode:
  A node without outgoing edges is removed.
  Should its weight become 0 or should it keep its weight?

- More than one user defined power function is allowed.

- More correlation matrices for standard designs + added unbalanced designs.

- Improved png export of graphs: Each side has only 5 pixel border.

- Defaults for epsilon in gMCP and substituteEps are now matching (10^{-3}).

- Updated references

- Fixed: GUI was more prone to rounding errors

- Fixed: Main vignette was missing in the binary zips

 52 files changed, 606 insertions(+), 212 deletions(-)


Changes in version 0.7-4 (22-01-2012, Rev. 1096)
================================================

- Many layout improvements.

- Edges have further attributes like color.

- Experimental support for copying the graph directly to the system clip board.
  (Seems to work for Windows - but no luck for Linux yet.)

- For people who create graphs in R and set the layout in the GUI: 
  If a node is dragged, edge weights also move except when they are "fixed".
  A node is set fixed, if it is dragged itself. 
  Saving and reloading a graph fixes all edges.

- LookNFeel and font size is now saved between sessions.
  
- CI dialog remembers less / greater option

- Thanks to .Rinstignore the file size of the installed packages is further reduced.

- Fixed: plotCI did not draw the CIs if all finite points were the same.

- Fixed: The bundled version closes the R console if the GUI is closed.
  
- Fixed: Report generation did not finish if no testing was performed beforehand.

 49 files changed, 1090 insertions(+), 561 deletions(-)


Changes in version 0.7-3 (16-01-2012, Rev. 1057)
================================================

- Function "subGraph" renamed to "subgraph" to avoid conflicts with
  package graph.

- Function "replaceVariables" exported and documented.

- Corrected labels in confidence interval dialog (weights instead alpha). 

- User submitted graphs are supported.

- Improved debug information.

- Dialog for loading of R objects gets "Cancel" button.

- GPL notice is shown when the GUI is used for the first time

- The bundled version closes the R console if the GUI is closed.

- Fixed: Since 0.7-2 too much output is printed to the R console.

- Fixed: Checking for updates happend on the event dispatch thread and
  in rare cases the GUI did not respond any more as long as the method 
  was trying to connect to the server.

- Fixed: Some objects with epsilon edges from gMCP < 0.7 could not
  be updated with function updateGraphToNewClassDefinition.
  
- Fixed: Since 0.7-1 graphGUI threw an error if the parameter graph is
  a character vector and an graph object with an equal name
  already existed.
  
- In addition to the RUnit tests gMCP is now also tested by JUnit tests.

 47 files changed, 362 insertions(+), 196 deletions(-)
 

Changes in version 0.7-2 (11-12-2011, Rev. 1016)
================================================

- Fixed: In 0.7-1 the options dialog throws an error.

- Fixed: In the verbose output of 0.7-1 some weights were shown 
  as p_i instead w_i.

- The dialogs for updating/deleting edges and nodes are now modal dialogs.

- The adjacency matrix is not editable while testing is in progress.

- Improved debug information

- Improved drag'n'drop. 
  Also edge labels do not jump any more when double clicked.

 29 files changed, 178 insertions(+), 198 deletions(-)


Changes in version 0.7-1 (22-11-2011, Rev. 1001)
================================================

- The GUI will (optionally) look for a newer version of 
  gMCP on CRAN.

- Simes test is available.

- New function "subGraph" for the creation of subgraphs.

- User defined power functions.

 52 files changed, 551 insertions(+), 266 deletions(-)
 
  
Changes in version 0.7-0 (26-Aug-2011, Rev. 964)
================================================

- Package "graph" is no longer a dependency.
  Class definition of graphMCP has changed and is no
  longer a subclass of graphNEL. The function
  gMCP:::updateGraphToNewClassDefinition(object)
  is provided to update old serialized (saved) objects.
  The GUI will use this function on its own if necessary.

- Also not longer a dependency: gtools, xtable, MCPAN

- New dependency: lattice graphics for power simulations

- Due to S4-methods and the optional "graph" package a lot
  of renaming has taken place:
  addEdge -> setEdge, edgeData -> edgeAttr, 
  nodeData -> nodeAttr, nodes -> getNodes 

- Power simulation code.

- New example graphs:

  - general and simple Successive Graphs
  - fixedSequence
  - Fallback Procedure
  - Truncated Holm (special case)
  - BauerEtAl2001
  - HuqueAloshEtBhore2011
  - BretzEtAl2009a/b/c

- Renaming of older example graphs to simpler names.

- CI dialog is modal.

- LaTeX-Code can be shown in Dialog and does not have 
  to be saved in a file.

- PValues can be attached to graphMCP objects as an 
  attribute "pvalues".
  
- Function graphGUI has a new parameter:
  experimentalFeatures=FALSE
  Set this to TRUE for experimental features like the following: 

- Power analysis in GUI.

- Code for adaptive procedures (marked as experimental).

 85 files changed, 2152 insertions(+), 1663 deletions(-)
  
    
Changes in version 0.6-6 (04-Jul-2011, Rev. 860)
================================================

- Fixed a bug in the GUI that deleted often p-values.

- Adjusted p-values are calculated also in the parametric case.

- Graphs without epsilon edges can be processed by a
  much faster procedure written in C.
  
- matrix2graph & graph2matrix deal better with variable edges.

- Hopefully setDividerLocation works now always correct, i.e. 
  the graph panel will always use 2/3 of the screen.
  
- Fractions like (1-a)/(1+b) are now shown with the 
  correct layout in the GUI.

- Speed up due to reduced Java/R communication.
  (More results are now cached in a Hashtable.)
  
 48 files changed, 559 insertions(+), 279 deletions(-)
  

Changes in version 0.6-5 (26-May-2011, Rev. 825)
================================================

- New dependency: CommonJavaJars
  This package contains now all the third party libraries.

- New example graphs:
  - Two versions of improved fallback procedures

- Improved placeNodes dialog.

- JavaGD plot is shown in CI dialog.

- Fixed bug with directory separators on Windows.

- Initialize the Java VM only if it is not initialized already.

 46 files changed, 157 insertions(+), 48 deletions(-)


Changes in version 0.6-4 (11-May-2011, Rev. 782)
================================================

- Fixed bug with saving and loading on Windows.

- Fixed bug with two graphs that could not be loaded.

- Fixed bug that the GUI expected a valid graph object on 
  start up.
  
- If an edge weights is 0 after variable replacement, 
  the edge is removed.
  
- Updated documentation that the graph package is not
  available any more on CRAN. 

- Layout of graph can be changed automatically from the GUI.

 22 files changed, 130 insertions(+), 38 deletions(-)

  
Changes in version 0.6-3 (09-May-2011, Rev. 767)
================================================

- New dependency: JavaGD, MCPAN

- Example graphs have been renamed (Please look at ?exampleGraph).

- Greek small letters are allowed as variables
  - enter them as e.g. "\epsilon", "\iota", "\phi" in the GUI.
  - use edgeData "variableWeight" to set them in R
    (see graph2FromBretzEtAl2009 as an example).
  - epsilon has to be entered as "\epsilon" instead of "e"

- Below the graphPanel is now a new panel with 
  graph description and graph analysis. 

- Function placeNodes is now exported with new parameters:
  nrow, ncol and force
  
- We use package highlight for the manuals.

- New example graphs:
   
  - Graphs from Hung and Wang (2010) and 
    Bretz et al. (2011)

- All example graphs have a description and
  graph attributes "description" are shown in the GUI.

- First data files: hydroquinone and simvastatin

- simConfint also returns the point estimates as second column.

- Improved compatibility for R 2.8.

- New HTML file References.html accessible from the GUI.
 
- Unified loading of graphs.

- New function: joinGraphs

- It looks like JavaGD is not available for Solaris?
  Anyone out there using this OS with gMCP?

75 files changed, 1398 insertions(+), 1117 deletions(-)


Changes in version 0.6-2 (24-Apr-2011, Rev. 679)
================================================

- New dependency: xtable 

- Indefinite ProgressPanel is shown while calculating.

- Calculations can be interrupted and canceled.

- Improved / updated gMCP-LaTeX-Report now in the GUI.

- New function: graphAnalysis

- Fixed a major bug which prevented saving/loading in the GUI.

- Mnemonic keys for the menu.

- Buttons for loading estimates / sd from R in CI-dialog.

- Improved zoom with TeXItem edge labels.

- Menu entry for loading p-values.

- Fixed visualization bug: 
  Panel with p-values was sometimes out of sync.

- Fixed bug: Edges with very small values were set to 0.

- Fixed visualization bug: 
  Adjacency table was not updated when edge was deleted.
  
- GUI deals a lot better with rounding errors.  

 58 files changed, 1072 insertions(+), 596 deletions(-)


Changes in version 0.6-1 (09-Apr-2011, Rev. 589)
================================================

- We use the library JLaTeXMath for edge labeling.

- Eye candy (for example the edge labels have now a border and 
  are always drawn at the end).
  
- The settings for correlation are moved to the p-value panel.

- The value for epsilon is optionally either asked every time
  or the value from the option panel is used.

- Changed the order of the buttons in the main button panel.

- GUI is remembering the last 4 used R objects / files. 

- Since r-forge has rJava problems at the moment and does
  not provide gMCP builds, we pushed 0.6-1 early to CRAN. 

 43 files changed, 666 insertions(+), 248 deletions(-)


Changes in version 0.6-0 (06-Apr-2011, Rev. 547)
================================================

- The GUI supports edges with variables (although sum checking of
  outgoing edges is disabled then till values are assigned to the
  variables.)
  
- gMCP has new arguments: approxEps=TRUE, eps=10^(-4)
  
- New function: substituteEps

- Changes in class graphMCP:
 
  - Attribute for node weights is called "nodeWeight".  

  - New mandatory edge attribute "epsilon".
  
- graph2latex has the new arguments "labelTikZ", "tikzEnv" and 
  "offset".
  
 40 files changed, 599 insertions(+), 339 deletions(-)


Changes in version 0.5-0 (28-Mar-2011, Rev. 525)
================================================

- We use weights instead of direct alpha allocation in the graphs.
  This causes major API changes:

  - gMCP and many other functions have an argument alpha with an
    default 0.05

  - getAlpha is now called getWeights since it returns the weights

  - graph2weights is removed since it is a special case of getWeights

- due to these changes above, graphs that have been saved to files
  will cause errors when loaded and processed

- getX/Y were renamed into getX/YCoordinates due to Rgraphviz
  conflicts.

- graph2latex has a new argument "nodeTikZ".

- new function bdiagNA for building block diagonal matrices with NA
  values outside the diagonal

- Backward compatibility for R 2.8.0 and rJava 0.6-3.

- CTRL+C interrupts only the last R command and does not close the
  whole R session.

- CRAN has disabled checks on arch="ppc", so MacOS builds are again
  available from CRAN.

- Bug report sends now also the result from traceback()

- A lot of bug fixes for corner and edge cases

- CITATION file

- Please note that full epsilon support is postponed for version 0.6-0

 61 files changed, 868 insertions(+), 482 deletions(-)


Changes in version 0.4-0 (21-Mar-2011, Rev. 462)
================================================

- Added code for graph based MCPs with partial knowledge of the
  correlation structure from Florian Klinglmueller, who is now
  coauthor.

- New dependencies in this code: gtools and multcomp (and therefore
  also mvtnorm)

- gMCP has a new optional parameter "correlation".

- The new vignette "correlated.pdf" shows the new features.

- graphGUI Parameter grid is now 0 by default. This restores the last
  used grid value.

- Fractions instead of decimal numbers are shown in more places.

- Alpha values can be entered as R expression, e.g. "0.05/7".

- When the test phase is started in the GUI, you are asked, whether
  you have (partial) knowledge about the correlations between the
  tests.

- Better support for more than one GUI window in the same R session.

- All help files open correctly on windows machines - even with 
  Java 5.0

 48 files changed, 278 insertions(+), 91 deletions(-)


Changes in version 0.3-6 (15-Mar-2011, Rev. 410)
================================================

- Mainly a bug-fix release, since the GUI was often not responding 
  in 0.3-5.

- C compiler is needed for building gMCP since the first C source file
  was added.

- When saving/loading graphs, reports or png/LaTeX files, the last
  directory is remembered.

- Adjusted p-values are now truncated and can not be bigger than one.

 36 files changed, 278 insertions(+), 495 deletions(-)


Changes in version 0.3-5 (13-Mar-2011, Rev. 379)
================================================

- Unfortunately after release it was noted that the GUI was not
  responding in 0.3-5.

- New dependencies: MASS for MASS::fractions and PolynomF for polynoms
  in epsilon.

- Saving and loading of graphs to/from files.

- Method graphGUI has a new optional argument "pvalues" for loading
  p-values.

- Trying to show fractions in the GUI instead of decimal numbers

- Line width of graphs can be adjusted (line width 2 is now default)

- Use of antialiasing for nicer graphics 

- Improvement of PNG exports

- Parameters for example graphs in GUI

- More RUnit tests

 40 files changed, 363 insertions(+), 406 deletions(-)


Changes in version 0.3-4 (26-Nov-2010, Rev. 341)
================================================

- New functions: graph2matrix and matrix2graph

- Adjaceny matrix is shown and can be edited.

 38 files changed, 152 insertions(+), 134 deletions(-)


Changes in version 0.3-3 (15-Nov-2010, Rev. 318)
================================================

- Be careful with epsilon edges (we never specified what exactly they
  are and how they should behave) and please wait for version 0.6
  which will handle them in a completely new way and will document it.
  Support for them is broken in this release.

- New example graph from Hommel et al. 2007.

- Inserted missing $ in LaTeX code output from graph2latex.

- Better automatic placement of edge labels.

- Options dialog in GUI.

- All doc files are accessible from the GUI menu.

- The GUI Locale object is always set to English - that way there is
  no decimal separator confusion etc.

- Edges with small weights are rendered better.

- Dialog that shows adjusted p-values with much better layout.

- New accompanying doc file: Description of Edges with Infinitesimal
  Small Epsilon Weights (unfinished). [Removed in 0.3-4]

- graph2latex has the same vertical orientation as the GUI.

- Option whether we want to still show already rejected nodes or not.

- Option whether graphs should be colored or not.

- Update in the GUI for confidence intervals to avoid a confused user.

- Removed function adjPValues from public API - adjusted p-values are
  now calculated in the gMCP call.

 33 files changed, 269 insertions(+), 282 deletions(-)


Changes in version 0.3-2 (08-Oct-2010, Rev. 277)
================================================

- Renaming of parameter in simConfint: "confintF" is now "confint"

- Updated confidence interval dialog (but still in development).

- Confidence intervals for t- and normal distribution can be
  calculated based on the p-values and point estimates in most cases.

- Reduced the package size.

- Further improved capabilities for bug reporting.

- We need rJava in version 0.8-3 or later.

- Vignette can be shown from inside the GUI.

- Function "setAlpha".

 36 files changed, 242 insertions(+), 110 deletions(-)


Changes in version 0.3-1 (02-Oct-2010, Rev. 249)
================================================

- The GUI has a menu bar.

- Improved capabilities for bug reporting. All information that is
  sent is also shown.

- Workaround for a problem with the graph package when a node has no
  out-going edges.

- Numbers are now accepted with "." and "," as decimal points

- A newly created edge is now by default an epsilon edge.

- Edges from one node to itself (loops) are not allowed any more.

- Start button is only enabled, if the graph has any nodes.

- Bug-fix regarding epsilon edges.

 25 files changed, 186 insertions(+), 113 deletions(-)


Changes in version 0.3-0 (01-Oct-2010, Rev. 238)
================================================

- Major API changes (mostly gsrmtp replaced by gMCP - but now the API
  should stay relatively stable).

- GraphGUI can now also be called directly on objects of class
  graphMCP, like graphGUI(rejectNode(graph, "H1")).

- Small GUI bug-fix for placing edge labels while in any other zoom
  level than 100%.

- Completely separated nodes (which only occur in sub-optimal testing
  procedures) are now handled correctly.

- If the graph has no nodeRenderInfo available when the GUI is called,
  the edges are placed in a circle.

- Deducer support if installed and loaded.

 42 files changed, 980 insertions(+), 930 deletions(-)


Changes in version 0.2-4 (30-Sep-2010, Rev. 215)
================================================

- After some alpha and beta releases on r-forge this is the first beta
  version on CRAN.

- We support: Graphs with epsilon edges, confidence intervals,
  adjusted p-values.
